package com.upyuns.platform.rs.website.controller.web;

import com.github.wxiaoqi.security.common.msg.ObjectRestResponse;
import com.github.wxiaoqi.security.common.rest.BaseController;
import com.upyuns.platform.rs.website.biz.OrderInfoBiz;
import com.upyuns.platform.rs.website.dto.*;
import com.upyuns.platform.rs.website.entity.OrderInfo;
import com.upyuns.platform.rs.website.service.ConfirmOrderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("orderInfo/web")
public class OrderInfoWebController extends BaseController<OrderInfoBiz,OrderInfo> {

	@Autowired
	ConfirmOrderService confirmOrderService;

	@PostMapping(value = "confirmOrder")
	public ObjectRestResponse confirmOrder(@RequestBody ConfirmOrderDto confirmOrderDto) {
		return confirmOrderService.confirmOrderInfo(confirmOrderDto);
	}

	@PostMapping(value = "submitOrder")
	public ObjectRestResponse submitOrder(@RequestBody OrderInfoDto orderInfoDto) {
		return baseBiz.submitOrder(orderInfoDto);
	}

	@GetMapping(value = "getOrderList")
	public ObjectRestResponse getUserOrder(UserOrderDto userOrderDto) {
		return baseBiz.getUserOrder(userOrderDto);
	}

	@GetMapping(value = "detail")
	public ObjectRestResponse getDetail(Long id) {
		return ObjectRestResponse.succ(baseBiz.getOrderDetail(id));
	}

	@GetMapping(value = "confirmReceived")
	public ObjectRestResponse confirmReceived(Long orderId) {
		return baseBiz.confirmReceived(orderId);
	}

	@PostMapping(value = "orderSend")
	public ObjectRestResponse orderSend(@RequestBody ConfirmReceivedDto confirmReceivedDto) {
		return baseBiz.orderSend(confirmReceivedDto);
	}

	@PostMapping(value = "setInvoice")
	public ObjectRestResponse setInvoice(@RequestBody OrderInvoiceDto orderInvoiceDto) {
		return baseBiz.setInvoice(orderInvoiceDto);
	}

	@PostMapping(value = "invoiceSend")
	public ObjectRestResponse invoiceSend(@RequestBody ConfirmReceivedDto confirmReceivedDto) {
		return baseBiz.invoiceSend(confirmReceivedDto);
	}

	@GetMapping(value = "confirmOrderInvoice")
	public ObjectRestResponse confirmOrderInvoice(Long orderId) {
		return baseBiz.confirmOrderInvoice(orderId);
	}

	@PostMapping(value = "cancelOrder")
	public ObjectRestResponse cancelOrder(@RequestBody OrderInfo orderInfo) {
		return baseBiz.cancelOrder(orderInfo);
	}

	@DeleteMapping(value = "deleteOrder")
	public ObjectRestResponse deleteOrder(Long orderId) {
		return baseBiz.deleteOrder(orderId);
	}
}